--------------------------------------
--		Build Helper		--
--		By Vectar666		--
--------------------------------------

--presetup
function initArray(m)
	local array = {}
	for i = 1, m do
		array[i]=0
	end
	return array
end
vbh_px=initArray(32)
vbh_py=initArray(32)
vbh_mode=initArray(32)

--hooks
addhook("say","vbh_say")
addhook("movetile","vbh_movetile")
addhook("spawn","vbh_spawn")
addhook("parse","vbh_con")

--funcs

function toTable(t,match)
     local cmd = {}
     if not match then
          match = "[^%s]+"
     else
          match = "[^"..match.."]+"
     end
     for word in string.gmatch(t, match) do
          table.insert(cmd, word)
     end
     return cmd
end

function vbh_con(text)
	if(text=="buildings_destroy_CT") then
		ii=object(0,"table")
		for i=1,#ii do
			if(player(object(i,"player"),"team")==2) then parse("killobject "..i) end
		end
		print("CT buildings destroyed")
		return 1
	elseif(text=="buildings_destroy_T") then
		ii=object(0,"table")
		for i=1,#ii do
			if(player(object(i,"player"),"team")==1) then parse("killobject "..i) end
		end
		print("T buildings destroyed")
		return 1
	elseif(text=="buildings_destroy_N") then
		ii=object(0,"table")
		for i=1,#ii do
			if(object(i,"player")==0) then parse("killobject "..i) end
		end
		print("Neutral buildings destroyed")
		return 1
	elseif(text=="buildings_destroy_ALL") then
		ii=object(0,"table")
		for i=1,#ii do
			parse("killobject "..i)
		end
		print("All buildings destroyed")
		return 1
	end
	iii=toTable(text)
	if(iii[1]=="buildings_destroy_player") then
		ii=object(0,"table")
		for i=1,#ii do
			if(object(i,"player")==tonumber(iii[2])) then parse("killobject "..i) end
		end
		return 1
	end
end

function vbh_say(id,message)
--Wall 1
	if (message=="-build wall 1") then
		vbh_mode[id]=3
		msg2(id,"Now placing wall 1")
		return 1
--Wall 2
	elseif (message=="-build wall 2") then
		vbh_mode[id]=4
		msg2(id,"Now placing wall 2")
		return 1
--Wall 3
	elseif (message=="-build wall 3") then
		vbh_mode[id]=5
		msg2(id,"Now placing wall 3")
		return 1
--Barricade
	elseif (message=="-build barricade") then
		vbh_mode[id]=1
		msg2(id,"Now placing barricade")
		return 1
--Barbed Wire
	elseif (message=="-build wire") then
		vbh_mode[id]=2
		msg2(id,"Now placing barbed wire")
		return 1
--Turret
	elseif (message=="-build turret 1") then
		vbh_mode[id]=8
		msg2(id,"Now placing turret")
		return 1
--Double Turret
	elseif (message=="-build turret 2") then
		vbh_mode[id]=11
		msg2(id,"Now placing double turret")
		return 1
--Triple Turret
	elseif (message=="-build turret 3") then
		vbh_mode[id]=12
		msg2(id,"Now placing triple turret")
		return 1
--Gate Field
	elseif (message=="-build gate field") then
		vbh_mode[id]=6
		msg2(id,"Now placing gate field")
		return 1
--Supply
	elseif (message=="-build supply") then
		vbh_mode[id]=9
		msg2(id,"Now placing supply")
		return 1
--Dispencer
	elseif (message=="-build dispencer") then
		vbh_mode[id]=7
		msg2(id,"Now placing dispencer")
		return 1
--Mine
	elseif (message=="-build mine") then
		vbh_mode[id]=20
		msg2(id,"Now placing mines")
		return 1
--Stop building
	elseif (message=="-build stop") then
		vbh_mode[id]=0
		msg2(id,"Now placing nothing")
		return 1
--DESTROY!!!
	elseif (message=="-destroy all") then
		ii=object(0,"table")
		for i=1,#ii do
			if(object(i,"player")==id) then parse("killobject "..i) end
		end
		msg2(id,"Your buildings have been destroyed")
		return 1
	end
end

function vbh_movetile(id,x,y)
	if(vbh_mode[id]>0) then
		parse("spawnobject "..vbh_mode[id].." "..vbh_px[id].." "..vbh_py[id].." 0 1 "..player(id,"team").." "..id)
	end
	vbh_px[id]=player(id,"tilex")
	vbh_py[id]=player(id,"tiley")
end

function vbh_spawn(id)
	vbh_px[id]=player(id,"tilex")
	vbh_py[id]=player(id,"tiley")
end